
class ArchivosController < ApplicationController



#Método create: Se recoge el archivo y se guarda en un carpeta. La tabla archivo guarda la ruta 
#al archivo y el nombre del mismo
	def create

    if params[:archivo][:fichero] == nil 
           @publicacion = Publicacion.find(params[:archivo][:publicacion])
           flash[:mensaje] = "Debe introducir un archivo"
           redirect_to publicacion_path(@publicacion)
    else
		    @publicacion = Publicacion.find(params[:archivo][:publicacion])
		    @miembro = Autor.find(params[:archivo][:miembro])
		    fichero = params[:archivo][:fichero]

        nombre = fichero.original_filename

        @existe = Archivo.where("nombre = '#{nombre}' AND publicacion_id = #{@publicacion.id}")
        if(@existe.blank?)
          directorio = "/publicaciones/#{@publicacion.id}/"
          extension = nombre.slice(nombre.rindex("."), nombre.length).downcase

          

          dirname = File.dirname("/publicaciones/#{@publicacion.id}/")
          FileUtils.mkdir_p(dirname) 
            
        
          if extension == ".pdf" 
              path= File.join('publicaciones',@publicacion.id.to_s)

              FileUtils.mkdir_p(path) unless File.exist?(path) 
              File.open(File.join(path, nombre), 'wb') do |file|
                  file.puts fichero.read
                end
              
              @archivo = @publicacion.archivos.create(url: "publicaciones/#{@publicacion.id}/#{nombre}" , nombre: nombre)
                   
              redirect_to publicacion_path(@publicacion)
          else
              flash[:mensaje] = "El archivo no es de un formato valido"
              redirect_to publicacion_path(@publicacion)
          end
        else
            flash[:mensaje] = "Existe un archivo para esta publicación con ese nombre"
              redirect_to publicacion_path(@publicacion)

        end   
          
        
           
     end
      
 	 end

#Método show: Recupera y descarga el archivo. 
 	 def show
        
            @archivo = Archivo.find(params[:id])
       
          send_file(@archivo.url)

 

 	 end

#Métodos destroy : elimina el archivo indicado
   def destroy

      @publicacion = Publicacion.find(params[:publicacion_id])
      @archivo = @publicacion.archivos.find(params[:id])
       File.delete(@archivo.url);
      @archivo.destroy
      redirect_to publicacion_path(@publicacion)
    end


end
