class AutorsController < ApplicationController

# En todos los métodos get se comprueba si hay un usuario que ha iniciado sesión. 

# Método index: devuelve todos los autores miembros
  def index 
   if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
      else
		@miembros =Autor.where("login!= '' ")
    @miembro = Autor.find(session[:user_id])
  end
    
	end


  # Método show: Recupera los datos de un autor 
	def show
    
      if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
      else
        @miembro = Autor.find(params[:id])
        
      end 

	end

#Método new: muestra el formulario para crear un nuevo autor
	def new 
    if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
      else
       @miembro = Autor.find(session[:user_id])
      @miembronew = Autor.new	
    end	
	end


  #Método edit: Recuperamos los datos del autor para poder mostrarles en pantalla con la opción
  #de ser editados
	def edit 


    if (session[:user_id] == nil || session[:user_id] == "")
		   redirect_to login_path
  
    else
      @miembroedit = Autor.find(params[:id])
      @miembro = Autor.find(session[:user_id])
      
    end
	end 

  #Método create: creamos un nuevo autor con los parámetros recogidos del formulario
	def create
    #encriptamos el pass para guardarlo en la base de datos 

        if(params[:autor][:login] != "")
          salt = "$2a$10$Qp/WgvQrrI0/H04BG0M.p."
          pass = BCrypt::Engine.hash_secret(params[:autor][:pass], salt)
        else 
          pass = ""
        end
          @miembronew = Autor.new(miembro_params)
          if @miembronew.save
              @miembronew.update(pass: pass)
              @miembro = Autor.find(session[:user_id])

              #un autor puede ser miembro o co-autor y un co-autor puede ser creado desde 
              #diferentes puntos de la aplicación. Es necesario comprobar de donde viene 
              #para hacer luego la redireccion
              if(params[:autor][:miembro])
              redirect_to listadomiembros_autors_path()
              else
                if(params[:autor][:coautor])
                  @lista = params[:autor][:lista]      
                  @lista<<@miembronew
                  if params[:autor][:coautor] == 'true'
                    redirect_to new_publicacion_path(lista: @lista, tipo: params[:autor][:tipo])
                  else
                     @participacion = @miembronew.participacions.create(publicacion_id: params[:autor][:coautor])
                     redirect_to publicacion_path(params[:autor][:coautor])
                  end
                else
                redirect_to listadocoautores_autors_path()
                end
              end
          else 

            @miembro = Autor.find(session[:user_id])
                if(params[:autor][:miembro])
                  @crearmiembro = ''
                  render  'new'
                else
                  if params[:autor][:coautor]
                    @lista = params[:autor][:lista]
                    @tipo = params[:autor][:tipo]
                    @coautor = params[:autor][:coautor]
                  render  'new'
                else
                  render 'new'
                end
                end
               
                
          end
       
      
 	 end

#Método update: guarda en la base de datos los datos (actualizados) del autor.
 	 def update 
       @miembroedit = Autor.find(params[:id])
       @miembro = Autor.find(session[:user_id])
 
       if @miembroedit.update(miembro_params)
            #flash[:mensaje] = "Datos actualizados correctamente"
          redirect_to autor_path(@miembro)
         

      else
        render 'edit'
      end
    end

#Método destroy: elimina de la base de datos el autor seleccionado.
#Se debe comprobar si el autor a eliminar es el unico autor de una publicación para así eliminar 
#la publicación, sus archivos y sus participaciones.
    def destroy
        @miembrodestroy = Autor.find(params[:id])
        @participaciones = @miembrodestroy.participacions
        @participaciones.each do |participacion|
           @otrosautores = Participacion.where("autor_id != #{@miembrodestroy.id}  AND publicacion_id = #{participacion.publicacion_id}")
           if@otrosMiembros.blank?
            @publicacion = Publicacion.find(participacion.publicacion_id)
            @publicacion.destroy
          else

            @otrosMiembros = Autor.where("login != '' AND id IN #{@otrosautores}")
              if  @otrosMiembros.blank?

                @publicacion = Publicacion.find(participacion.publicacion_id)
                @publicacion.destroy

              else
              end

           end
           
        end

        @miembrodestroy.destroy
         @miembro = Autor.find(session[:user_id])

        #flash[:mensaje] = "#{@miembro.rol} #{@miembro.nombre} eliminado correctamente"
       #redirect_to miembro_administrador_path(@current_miembro)
       if(params[:coautor])
        redirect_to listadocoautores_autors_path()
       else
        redirect_to listadomiembros_autors_path()
       end
       
        
    end



#Recoge los diferentes departamentos para mostrar los autores miembros por departamentos
def listadomiembrosdepartamento
  
  @departamentos = Autor.select("departamento").distinct


end




  #buscamos todas las publicaciones de un autor . Aqui se accede haciendo click en el nombre 
  #del autor en la lista de publicaciones
def resultadoautor

if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
      else
      #@participanesbusqueda = Participacion.select("id_publicacion").where("id_miembro IN (#{params[:autores]})")
      params[:participaciones] = "SELECT publicacion_id FROM participacions WHERE autor_id = '#{params[:autor_id]}'"
      @publicacionesresultado = Publicacion.where("id IN (#{params[:participaciones]})")
      end 

  end


#muestra el formulario donde se solicita la contraseña antes de que esta sea cambiada
def securitycambiarcontrasena
  if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
      else

  @miembro = Autor.find(session[:user_id])
end

end

#muestra el formulario para cambiar la contraseña
def cambiarcontrasena
  if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
      else
    @miembro = Autor.find(session[:user_id])
  end

end

#antes de cambiar la contraseña comprobamos que el miembro que quiere cambiarla es quien dice ser
#para ello le pedimos que introduzca la contraseña actual 
def verificarcontrasena
  if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
   else
        @miembro = Autor.find(params[:autor_id])
      salt = "$2a$10$Qp/WgvQrrI0/H04BG0M.p."
      pass = BCrypt::Engine.hash_secret(params[:miembro][:pass], salt)
           
      if @miembro.pass == pass
        redirect_to autor_cambiarcontrasena_path(@miembro)
      else
        flash[:mensaje] = "La contraseña es incorrecta"
        redirect_to autor_securitycambiarcontrasena_path(@miembro)
      end
    end
end

#cambiar contraseña. Comprobamos que las contraseña y la repeticion son iguales, a continuacion
#encriptamos la contraseña y la actualizamos 
def updatecontrasena

  if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
  else
        @miembro = Autor.find(params[:autor_id])
      if(params[:miembro][:pass] == "" || params[:miembro][:repass] == "")

        flash[:mensaje] = "Debe rellenar todos los campos"
            redirect_to autor_cambiarcontrasena_path(@miembro)

      else

        if params[:miembro][:pass] == params[:miembro][:repass]
          salt = "$2a$10$Qp/WgvQrrI0/H04BG0M.p."
          pass = BCrypt::Engine.hash_secret(params[:miembro][:pass], salt)
          @miembro.update(pass: pass)

     
          reset_session
          redirect_to login_path
        else
           flash[:mensaje] = "La repetición de la contraseña no coincide, vuelve a internarlo"
            redirect_to autor_cambiarcontrasena_path(@miembro)
        end
      end

  end
    
end

#recupera la lista de los miembros, es decir autores pertenecientes al grupo
#para mostrarlos por pantalla
def listadomiembros
  if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
      else
  @miembros = Autor.where("login != ''")
  @miembro = Autor.find(session[:user_id])
end
end


#recupera la lista de los colaboradores, es decir autores no pertenecientes al grupo,
#para mostrarlos por pantalla
def listadocoautores

  if(session[:user_id] == nil || session[:user_id] == "")
        redirect_to login_path
  else
    @colaboradores = Autor.where("login = ''")
    @miembro = Autor.find(session[:user_id])
  end

end


#Definimos los parametros que permitimos a la hora decrear un nuevo miembro
 	private
  		def miembro_params
    		params.require(:autor).permit(:nombre, :login, :pass, :rol, :departamento, :correo, :ciudad, :web , :apellido)
  		end

end
