class SessionsController < ApplicationController

 #Muestra el formulario de acceso. En caso de que en la sesion ya exista un miembro 
 #redirige al panel 
def new 

  if(session[:user_id] == nil || session[:user_id] == "")
        
  else
      @miembro = Autor.find(session[:user_id])
      redirect_to autor_path(@miembro)
  end

end

#Comprueba si los datos de inicio de sesion pertenecen a algun miembro y si son correctos. De ser 
#así se guarda el miembro en la sesion
def create

  
  #comprobamos que se haya rellenado tanto el login como el pass
	 if(params[:miembro][:user]== "" || params[:miembro][:pass] == "" )
            flash[:mensaje] = "Debe rellenar todos los campos"
            redirect_to login_path
    else
      #comprueba que en la base de datos existe un usuario con ese login
        if Autor.find_by login: params[:miembro][:user] 
          
          @miembro = Autor.find_by login: params[:miembro][:user] 
          #si el usuario existe comprobamos que la contraseña introducida es correcta
          #debemos tener en cuenta que la contraseña en la BD esta encriptada 
           salt = "$2a$10$Qp/WgvQrrI0/H04BG0M.p."
          pass = BCrypt::Engine.hash_secret(params[:miembro][:pass], salt) 
          
          #if @miembro.pass ==  params[:miembro][:pass]
          if @miembro.pass == pass
            #si los datos son correctos guardamos su id en la sesion para usos posteriores
            session[:user_id] = @miembro.id;
            #comprobamos su rol y le damos acceso al panel correspondiente a su rol
            
            redirect_to autor_path(@miembro)
          #si la contraseña es incorrecta mostramos un mensaje al usuario indicando el error
          else
            flash[:mensaje] = "La contraseña es incorrecta "
            redirect_to login_path
          end
          #si no existe ningun usuario con ese login se indica del error al usuario.
        else
          flash[:mensaje] = "El usuario no existe"
         redirect_to login_path
        end
      end


end

#Se destruyela sesion
def destroy
  #borramos la sesion y volvemos al inicio
	session[:user_id] = "-1"
    reset_session
    redirect_to root_path
end

end
